# CBComponents.CBBasicHistogram
```author: 王超  mail: wb-wc257202@alibaba-inc.com```
### 组件描述

多柱图基础组件

### 引入方式

import { CBBasicHistogram } from 'citybrain'

### 组件属性

| 成员        | 说明           | 类型               | 默认值       |
|-------------|----------------|--------------------|--------------|
| dataSource          | 数据源   | array: [{name: 'aa', 'xx': 'yyy'}, {name: 'bb', 'xx': 'zzz'}], name为柱状图名称，xx为x轴展示， yyy,zzz为y轴展示（单x多柱状图） | null        |
| thresholdLevel      | 基准线纵轴数值        | number                  | null        |
| height      | 图表的高度        | number                  | 250        |
| padding      | 图表的padding        | array                  | [5, 30, 30, 38] 上右下左       |
| colorMap      | 图例map        | object, {key: value} key:图例说明文字， value： 颜色, key要与 dataSource中 name字段对应                | null       |
| noDataText      | 无数据时的文案展示（支持国际化）        | string                  | 数据为空        |
| guideLineText      | 图例辅助线的文案（阈值）        | string                  | null        |
| unit      | tooltip和y轴的单位        | string                  | 小时        |

### 示例用法
```

const rampData = [
  {
    '2018-02-03': 14,
    '2018-02-04': 9.666667,
    '2018-02-10': 6.466667,
    '2018-02-15': 5,
    '2018-02-16': 4.533333,
    '2018-02-17': 4.1,
    '2018-02-18': 4.433333,
    '2018-02-19': 4.6,
    '2018-02-20': 4.8,
    '2018-02-21': 7.433333,
    '2018-02-25': 5.6,
    name: '主线下游'
  },
  {
    '2018-02-03': 9,
    '2018-02-04': 9.666667,
    '2018-02-10': 6.466667,
    '2018-02-15': 5,
    '2018-02-16': 4.533333,
    '2018-02-17': 4.1,
    '2018-02-18': 4.433333,
    '2018-02-19': 4.6,
    '2018-02-20': 4.8,
    '2018-02-21': 7.433333,
    '2018-02-25': 5.6,
    name: '主线上游'
  }
]
const colorMap = { '主线上游': 'red', '主线下游': 'yellow' }

<CBBasicHistogram dataSource={rampData} thresholdLevel={30} guideLineText='阈值' colorMap={colorMap} unit='分钟' />
```