# CBComponents.CBCrossChart
```author: 王超  mail: wb-wc257202@alibaba-inc.com```
### 组件描述

路口规律研判柱状图

### 引入方式

import { CBCrossChart } from 'citybrain'

### 组件属性

| 成员        | 说明           | 类型               | 默认值       |
|-------------|----------------|--------------------|--------------|
| dataSource          | 数据源   | array: [{date: 'xx', time: 'xx'}], date为x轴, time为y轴 | null        |
| thresholdLevel      | 基准线纵轴数值        | number                  | null        |
| height      | 图表的高度        | number                  | 250        |
| unit      | 图表以及tooltip的单位        | string                  | 小时        |
| padding      | 图表的padding        | array                  | [10, 30, 30, 40] 上右下左        |
| legendText      | 图例对应文字        | string                  | null        |
| guideLineText      |      图例辅助线的文案（阈值   | string                  | null        |

### 示例用法
```

const crossData = () => {
  let data = []
  for (var i = 1; i < 30; i++) {
    if (i < 10) {
      data.push({date: `2017/11/0${i}`, time: 30 - i})
    } else {
      data.push({date: `2017/11/${i}`, time: 30 + i})
    }
  }
  return data
}

<CBCrossChart dataSource={crossData()} thresholdLevel={20} unit='h' legendText='拥堵时11长拥堵时' guideLineText='拥堵阈值拥堵时11' />
```