# CBComponents.CBSpeedChart
```author: 王超  mail: wb-wc257202@alibaba-inc.com```
### 组件描述

路段车速分析柱状图

### 引入方式

import { CBSpeedChart } from 'citybrain'

### 组件属性

| 成员        | 说明           | 类型               | 默认值       |
|-------------|----------------|--------------------|--------------|
| dataSource          | 数据源   | array: [{name: 'xx', speed: 'xx'}], name为x轴, speed为y轴 | null        |
| thresholdLevel      | 基准线纵轴数值        | number                  | null        |
| height      | 图表的高度        | number                  | 250        |
| title      | tooltip title 展示        | string                  | ''        |
| padding      | 图表的padding        | array                  | [10, 30, 30, 40] 上右下左        |
| legendText      | 图例对应文字        | string                  | null        |
| guideLineText      |      图例辅助线的文案（阈值   | string                  | null        |

### 示例用法
```

const speedData = () => {
  let data = []
  for (var i = 0; i < 10; i++) {
    data.push({
      name: `猎德大道至洗${i}`,
      speed: 50 - i,
      sj: 50
    })
  };
  return data
}

<CBSpeedChart dataSource={speedData()} height={150} title='周二 00:00~11:57' legendText='实际平均通行速度拥堵时11长拥堵时11长' guideLineText='拥堵阈值拥堵时11长拥堵时11长拥堵时11长拥堵时11长拥堵时11长' />
```