# CBComponents.CBAppHeader
```author: 王超  mail: wb-wc257202@alibaba-inc.com```
### 组件描述

应用公共头部，支持中英文切换，注销功能,支持下拉菜单，横向导航

### 引入方式

import { CBAppHeader } from 'citybrain'

### 组件属性

| 成员        | 说明           | 类型               | 默认值       |
|-------------|----------------|--------------------|--------------|
| menu          | 横向导航   | React组件 | null        |
| selectedApp          | 当前选中的应用，对应应用的id   | Number或者string(与appList中name字段值对应即可) | 默认第一个应用的id或者空        |
| userName      | 用户名称展示| String         | ''        |
| appList       | 应用选择数据源 | Array:[{'appId': '10001', 'appName': 'xxxx', 'appNameEn': 'xxx'}] (appId， appName, appNameEn 为必传字段))                 | null        
| onExit      | 点击退出（注销）时的回调       | func               | 若不传执行默认注销逻辑        |
| onLogoClick      | 点击logo时的回调       | func               | null        |
| onAppItemClick      | 选择应用列表时的回调       | func(item), item: 所选数据源               | null|
| menuList      | 当menu没传时，传入数据源，也可生成横侧导航，       | Array:[{id, name}]               | undefined        |
| onMenuClick      | 传入menuList时，点击横侧导航的回调       | func(item)    item: 所选数据源            | null      |
| selectedKeys      | 传入menuList时，点击横侧导航的选中态       | Array:[num], num为选中项在数据里的index               | null        |
| langBarShow      | 语言切换框的展示态       | Boolean               | true        |
| userinfoShow      | 用户信息栏的展示态       | Boolean               | true        |
| logoDom      | 自定义图表      | react组件               | 城市大脑图表        |
| theme      | 主题颜色(light or dark or blue)       | string               | dark        |
| showMessage      | 消息栏展示       | boolean               | false        |
| dotShow      | 消息栏展示的状态下， 提示红点的展示态       | boolean               | false        |



### 示例用法
```
<CBAppHeader
  onExit={()=>{console.info('exit')}}
  appList={[{appId: "10001", appAuthor: "", appName: "交通态势与信号优化", appNameEn: "Traffic State Perception and Traffic Light Optimization", appPath: "/app/situation-analysis"}]} selectedApp={'10001'} menu={menu} userName={'xxx'} />





  # CBComponents.CBHomeHeader
```author: 王超  mail: wb-wc257202@alibaba-inc.com```
### 组件描述

首页公共头部，支持中英文切换，注销功能,支持下拉菜单，横向导航

### 引入方式

import { CBHomeHeader } from 'citybrain'

### 组件属性

| 成员        | 说明           | 类型               | 默认值       |
|-------------|----------------|--------------------|--------------|
| menu          | 横向导航   | React组件 | null        |
| userName      | 用户名称展示| String         | ''        |      
| onExit      | 点击退出（注销）时的回调       | func               | 若不传执行默认注销逻辑        |
| onLogoClick      | 点击logo时的回调       | func               | null        |
| menuList      | 当menu没传时，传入数据源，也可生成横侧导航，       | Array:[{id, name}]               | undefined        |
| onMenuClick      | 传入menuList时，点击横侧导航的回调       | func(item)    item: 所选数据源            | null      |
| selectedKeys      | 传入menuList时，点击横侧导航的选中态       | Array:[num], num为选中项在数据里的index               | null        |
| langBarShow      | 语言切换框的展示态       | Boolean               | true        |
| userinfoShow      | 用户信息栏的展示态       | Boolean               | true        |
| logoDom      | 自定义图表      | react组件               | 城市大脑图表        |
| theme      | 主题颜色( dark or blue)       | string               | dark        |
| showMessage      | 消息栏展示       | boolean               | false        |
| dotShow      | 消息栏展示的状态下， 提示红点的展示态       | boolean               | false        |



### 示例用法
```
<CBHomeHeader
  onExit={()=>{console.info('exit')}}
   menu={menu} userName={'xxx'} />
```
```